from time import sleep
import RPi.GPIO as GPIO

class RGBA():
    def __init__(self, r, g, b):
        GPIO.setmode(GPIO.BCM)
        channel = [r, g, b]
        for c in channel:
            GPIO.setup(c, GPIO.OUT)
        self.r = GPIO.PWM (r, 120) # channel = 12 frequency = 60Hz
        self.g = GPIO.PWM (g, 120) # channel = 13 frequency = 60Hz
        self.b = GPIO.PWM (b, 120) # channel = 19 frequency = 60Hz
        
        self.r.start(0)
        self.g.start(0)
        self.b.start(0)
        
    # 0 -255 for r, g, b
    def setColor(self, r, g, b):
        r = 100 - ( r / 255 ) * 100
        g = 100 - ( g / 255 ) * 100
        b = 100 - ( b / 255 ) * 100
        print(r, g, b)
        
        self.r.ChangeDutyCycle(r)
        self.g.ChangeDutyCycle(g)
        self.b.ChangeDutyCycle(b)

led = RGBA (12, 13, 19)
led.setColor ( 70, 34, 84 )
sleep(3)
GPIO.cleanup()